Bookpal/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('library.urls')),
    path('account/', include('account.urls')),
    path('account/', include('account.urls2')),
]

account/urls.py
from django.urls import path, include

from . import views

app_name="account"

urlpatterns = [
        path('login/', views.user_login, name = 'login'),
        path('logout/', views.user_logout, name = 'logout'),
        path('', views.dashboard, name = 'dashboard'),
        path('register/', views.register, name='register'),
        path('users/', views.users_list, name="users_list"),
        path('users/<username>/', views.user_info, name="user_info"),
        path('edit_profile/', views.edit_profile, name="profile_edit")
]

library/urls.py
from django.urls import path

from . import views

app_name = "library"

urlpatterns = [
        path('', views.index, name = 'index'),
        path('library/', views.redirect_to_index),
        path('library/<slug:book_slug>', views.book_info, name='book'),
        path('library/category/<cate>', views.category, 
                                            name='category'),
]

library/models.py
from django.db import models
from django.conf import global_settings
from django.utils import timezone
from django.core.validators import MaxValueValidator, MinValueValidator

class Author(models.Model):
    
    author_name = models.CharField(max_length=50)

    author_major_field = models.CharField(max_length=50)

    author_description = models.TextField()

    def __str__(self):
        return self.author_name

class Book(models.Model):
    book_name = models.CharField(max_length=50)

    book_slug = models.SlugField(max_length=60)
    
    GENRES_LIST = (
                    ("fantasy", "Fantasy"), 
                    ("sci-fi", 'Sci-Fi'),
                    ('mystery', 'Mystery'),
                    ('thriller', 'Thriller'),
                    ('romance', 'Romance'),
                    ('western','Western'),
                    ('dystopian','Dystopian'),
                    ('contemporary', 'Contemporary')
                )
    book_genre = models.CharField(max_length=30, choices=GENRES_LIST)
    
    book_published_date = models.DateField()

    book_score_count = models.IntegerField(default=0, validators=[MinValueValidator(0)])

    book_score_sum = models.IntegerField(default=0, validators=[MinValueValidator(0)])
    def get_book_score(self):
        try:
            return self.book_score_sum / self.book_score_count
        except:
            return 0

    book_description = models.TextField()

    book_author = models.ForeignKey(Author, on_delete=models.CASCADE,
                                    related_name = "author_books")

    #book_pic = 


    def __str__(self):
        return self.book_name

class UserProfile(models.Model):
    profile_user = models.OneToOneField(global_settings.AUTH_USER_MODEL,
                                    on_delete=models.CASCADE,
                                    related_name="user_profile")

    profile_status = models.CharField(max_length=10, choices=(('online', 'Online'), ('offline', 'Offline')))

    def __str__(self):
        return self.profile_user.username

class BookProfile(models.Model):

    bookprofile_expire = models.DateTimeField()

    bookprofile_user = models.ForeignKey(UserProfile, on_delete=models.CASCADE,
                                            related_name="profile_books_borrowed")

    bookprofile_book = models.ForeignKey(Book, on_delete=models.CASCADE)

    def __str__(self):
        return "{0} borrowed by:{1}, until {2}".format(self.bookprofile_book,
                                                    self.bookprofile_user,
                                                    self.bookprofile_expire)

library/forms.py
from django import forms
from django.contrib.auth.models import User
from .models import BookProfile
from django.contrib.admin import widgets
import datetime

class BorrowForm(forms.Form):
    expire_date = forms.DateField(widget=forms.SelectDateWidget(),
                                initial=datetime.date.today() + 
                                datetime.timedelta(days=1))

    def clean_expire_date(self):
        expire_date = self.cleaned_data['expire_date']
        if expire_date < datetime.date.today():
            raise forms.ValidationError("The expire date cannot be in the past!!")
        return expire_date

library/views.py
from django.shortcuts import render, get_object_or_404
from django.http import HttpResponse, HttpResponseRedirect, Http404
from django.urls import reverse

from .models import Book, BookProfile
from .forms import BorrowForm


# Create your views here.
def index(req):
    latest_books = Book.objects.order_by('-book_published_date')[:3]
    categories = []
    for i, j in Book.GENRES_LIST:
        categories.append(i)
    return render(req, 'library/index.html', { 'latest_books':latest_books,
                                            'categories':categories })

def category(req, cate):
    ls = [i[0] for i in Book.GENRES_LIST]
    if cate in ls:
        books = Book.objects.filter(book_genre=cate)
        return render(req, 'library/category.html', { 'books': books, 'cate':cate })
    else:
        raise Http404

def book_info(req, book_slug):
    
    book = get_object_or_404(Book, book_slug=book_slug)
    
    try:
        book_profile = BookProfile.objects.get(bookprofile_user=req.user.user_profile, bookprofile_book=book)
    except:
        book_profile = None
    
    try:
        score = book_score_sum / book_score_count
    except:
        score = 0

    if req.method != "POST":
        borrow_form = BorrowForm()
    else:
        borrow_form = BorrowForm(data=req.POST)
        if borrow_form.is_valid():
            cd = borrow_form.cleaned_data
            new_book = BookProfile.objects.create(bookprofile_expire=cd['expire_date'], bookprofile_user=req.user.user_profile, bookprofile_book = book)
            return HttpResponseRedirect(req.path)

    return render(req, 'library/book_info.html', { 'book': book,
                                        'book_profile':book_profile,
                                        'score':score,
                                        'borrow_form':borrow_form})

def redirect_to_index(req):
    return HttpResponseRedirect(reverse('library:index'))

library/templates/library/book_info.html
{% extends "base.html" %}

{% block title %}{{ book.book_name }}{% endblock %}

{% block content %}
	<br>
	<h3>{{ book.book_name }}</h3>
	<ul>
		<li>Name: {{ book.book_name }}</li>
		<li>Genre: {{ book.book_genre }}</li>
		<li>Author: {{ book.book_author }}</li>
		<li>Published: {{ book.book_published_date }}</li>
		<li>Score: {{ score }} / 5</li>
		<hr>
		<li>Description: {{ book.book_description }}</li>
	</ul>
	<hr>
	{% if not book_profile and request.user.is_authenticated %}
	<form method="post">
		{{ borrow_form.as_p }}
		{% csrf_token %}
		<p><input type="submit" value="Borrow book"></p>
	</form>
	{% else %}
		{% if request.user.is_authenticated %}
		<p>This book is on your <a href="{% url "account:dashboard" %}">borrowed book list</a></p>
		{% endif %}
	{% endif %}

{% endblock %}

library/templates/library/category.html
{% extends 'base.html' %}

{% block title %}{{ cate }}{% endblock %}

{% block content %}
<h2>{{ cate }}</h2>
<br>
{% if books %}
{% for book in books %}
<div class="book_icon">
<h3><a href="{% url 'library:book' book.book_slug %}">{{ book.book_name }}</a></h3>
<p>{{ book.book_author }}</p>
<p>{{ book.get_book_score }}</p>
<hr>
</div>
{% endfor %}
{% else %}<p>There is no book in this category</p>{% endif %}

{% endblock %}

library/templates/library/index.html
{% extends "base.html" %}
{% load app_filters %}

{% block title %}BookPal{% endblock %}

{% block content %}
<h2>Latest books</h2>
{% for book in latest_books %}
<div class="book_icon">
	<h3><a href="{% url 'library:book' book.book_slug %}">{{ book.book_name }}</a></h3>
	<p>{{ book.book_author }}</p>
	<p>{{ book.get_book_score }}</p>
	<hr>
</div>
{% endfor%}

<hr>
<h2>Categories</h2>
{% for category in categories %}
<a href="{% url 'library:category' category %}">{{ category }}</a>&nbsp;
{% if forloop.counter0|modulo:3 == 2 %}<br>{% endif %}
{% endfor %}

{% endblock %}